<template>
    <div class="create-task-box">
      <form @submit.prevent="submit">
        <textarea v-bind:class="{ 'has-error': titleNotValid }" rows="3" class="form-input d-block" type="text" placeholder="Please enter task title" v-model="title"></textarea>
        <span v-if="titleNotValid" class="alert-box">
          {{ titleNotValid }}
        </span>
        <button class="btn btn-submit" type="submit" name="button">Add</button>
      </form>
    </div>
</template>
<script>
import { mapMutations } from 'vuex';

export default {
  name: 'CteateTaskModal',

  props: ['group_id'],

  data() {
   return {
     title: '',
     titleMinLenght: 3,
     titleMaxLenght: 100,
     titleNotValid: false
    }
  },

  methods: {

   ...mapMutations({createTask: "tasks/ADD_TASK"}),

   submit(){
     if(this.title.trim().length < this.titleMinLenght){
       this.titleNotValid = 'Title must be at least '+ this.titleMinLenght +' characters';
     }
     else if (this.title.trim().length > this.titleMaxLenght) {
       this.titleNotValid = 'Title can be maximum '+ this.titleMaxLenght +' characters';
     }
     else {
       this.createTask({
         id: Date.now(),
         title: this.title,
         group_id: this.$props.group_id
       });
       this.$emit('close');
     }
   }

  }
}
</script>
